
/*
muduo网络库给用户提供了两个主要的类
TcpServer ：用于编写服务器程序的
TcpClient ：用于编写客户端程序的

epoll+线程池
好处 ：能够把网络I/O的代码和业务代码区分开
   用户的连接和断开 用户的可读写事件  
*/

#include <muduo/net/TcpServer.h>
#include <muduo/net/EventLoop.h>
#include <iostream>
#include <functional>
using namespace std;
using namespace muduo;
using namespace muduo::net;
using namespace placeholders;

class ChatServer{
public:
    ChatServer(EventLoop* loop,
            const InetAddress& listenAddr,
            const string& nameArg)
        :_server(loop,listenAddr,nameArg),_loop(loop)
    {
        //给服务器注册用户连接的创建和断开回调
        _server.setConnectionCallback(std::bind(&ChatServer::onConnection, this, _1));
        //给服务器注册用户读写事件的回调
        //_server.setMessageCallback();
    }

private:
    void onConnection(const TcpConnectionPtr&)
    {  

    }

     void Message(const MessageCallback& cb)
    {

    }

    TcpServer _server;
    EventLoop* _loop;
};







